import bb.cascades 1.4

CustomListItem {
    property alias title: titleLabel.text
    property alias description: descriptionLabel.text
    property alias imageSource: icon.imageSource 
    property alias expanded: descriptionLabel.visible

    Container {
        layout: StackLayout { orientation: LayoutOrientation.LeftToRight}
        leftPadding: ui.du(2)
        rightPadding: ui.du(2)
        topPadding: ui.du(1)
        bottomPadding: ui.du(2)
        ImageView {
            id: icon
            imageSource: "asset:///permicons/_unknown.png"
            minHeight: 96
            minWidth:  96
            verticalAlignment: VerticalAlignment.Center
            rightMargin: ui.du(2)
        }
        Container {
            Label {
                id: titleLabel
                text: "access_internet"
                textFormat: TextFormat.Plain
                textStyle.fontWeight: FontWeight.Bold
                multiline: true
            }
            Label {
                id: descriptionLabel
                text: "Use the Internet connection from a Wi-Fi, wired, or other type of connection to access locations that are not local on the device."
                textFormat: TextFormat.Plain
                multiline: true
                topMargin: ui.du(0.5)
            }
        }
    }
}
