const UNDOCUMENTED_PERMISSION_DESCR = qsTr("(Undocumented permission)", "Generic description for unknown/undocumented permissions");
const PERMISSION_INFO = {
	"_sys_access_pim_unified": {
		"name": qsTr("Hub Integration", "Name of the _sys_access_pim_unified permission"),
		"description": qsTr("Allows the app to integrate with the BlackBerry Hub. With this permission, the app can create and manage data in the BlackBerry Hub. This permission is restricted to developers specifically authorised by BlackBerry.", "Description of the _sys_access_pim_unified permission"),
		"iconFile": "hub.png"
	},
	"_sys_access_smartcard_api": {
		"name": qsTr("Smart Card", "Name of the _sys_access_smartcard_api permission"),
		"description": qsTr("Allows the app to encrypt, decrypt, sign, and verify data using a smart card.", "Description of the _sys_access_smartcard_api permission"),
		"iconFile": "smart_card.png"
	},
	"_sys_smart_card_driver": {
		"name": qsTr("Smart Card Driver", "Name of the _sys_smart_card_driver permission"),
		"description": qsTr("Allows third-party smart card drivers and smart card reader drivers to integrate with the Smart Card service.", "Description of the _sys_smart_card_driver permission"),
		"iconFile": "smart_card.png"
	},
	"_sys_access_extended_smartcard_functionality": {
		"name": qsTr("Smart Card Extended", "Name of the _sys_access_extended_smartcard_functionality permission"),
		"description": qsTr("Allows the app to use Application Protocol Data Unit (APDU) for custom commands.", "Description of the _sys_access_extended_smartcard_functionality permission"),
		"iconFile": "smart_card.png"
	},
	"_sys_allow_extend_data_lock": {
		"name": qsTr("ADARP Extend Data Lock", "Name of the _sys_allow_extend_data_lock permission"),
		"description": qsTr("As part of advanced data at rest protection (ADARP), this permission allows the app to be able to extend the time before the work space switches into a data lock state.", "Description of the _sys_allow_extend_data_lock permission"),
		"iconFile": "data_lock.png"
	},
	"_sys_headless_nostop": {
		"name": qsTr("Run in Background Continuously", "Name of the _sys_headless_nostop permission"),
		"description": qsTr("Allows the app to run in the background as a long-running headless app.", "Description of the _sys_headless_nostop permission"),
		"iconFile": "run_in_background.png"
	},
	"_sys_inject_events": {
		"name": qsTr("Automatic Input Control", "Name of the _sys_inject_events permission"),
		"description": qsTr("Allows the app to simulate touchscreen gestures and keys being pressed on a keyboard.", "Description of the _sys_inject_events permission"),
		"iconFile": ""
	},
	"_sys_inject_voice": {
		"name": qsTr("Phone Audio Overlay", "Name of the _sys_inject_voice permission"),
		"description": qsTr("Allows the app to add audio to a phone call.", "Description of the _sys_inject_voice permission"),
		"iconFile": "phone.png"
	},
	"_sys_manage_pimdomain_external_accounts": {
		"name": qsTr("Hub Accounts", "Name of the _sys_manage_pimdomain_external_accounts"),
		"description": qsTr("Allows the app to create a custom account that's accessible in the BlackBerry Hub. This permission is restricted to developers specifically authorised by BlackBerry.", "Description of the _sys_manage_pimdomain_external_accounts permission"),
		"iconFile": "accounts.png"
	},
	"_sys_register_vpnextensions_servicepath": {
		"name": "",
		"description": UNDOCUMENTED_PERMISSION_DESCR,
		"iconFile": "vpn.png"
	},
	"_sys_run_headless": {
		"name": qsTr("Run in Background", "Name of the _sys_run_headless permission"),
		"description": qsTr("Allows the app to perform certain tasks in the background without opening the app.", "Description of the _sys_run_headless permission"),
		"iconFile": "run_in_background.png"
	},
	"_sys_use_consumer_push": {
		"name": qsTr("Push", "Name of the _sys_use_consumer_push permission"),
		"description": qsTr("Allows the app to use BlackBerry Push Service with BlackBerry Internet Service. This permission allows an app to receive and request push messages. To use the Push Service with the BlackBerry Internet Service, the developer must register with BlackBerry.\nIt is important to be aware that if the app uses the Push Service with the BlackBerry Enterprise Server or the BlackBerry Device Service, the developer does not need to register with BlackBerry, and does not have to add the Push permission for the app.", "Description of the _sys_use_consumer_push permission"),
		"iconFile": "push.png"
	},
	"access_internet": {
		"name": qsTr("Access Internet", "Name of the access_internet permission"),
		"description": qsTr("Use the Internet connection from a Wi-Fi, wired, or other type of connection to access locations that are not local on the device.", "Description of the access_internet permission"),
		"iconFile": "internet.png"
	},
	"access_led_control": {
		"name": qsTr("Control LED", "Name of the access_led_control permission"),
		"description": qsTr("Allows the app to monitor and control the status of the LED on the device (flashing, colors, etc).", "Description of the access_led_control permission"),
		"iconFile": "led.png"
	},
	"access_location_services": {
		"name": qsTr("Access Location", "Name of the access_location_services permission"),
		"description": qsTr("Allows the app to access the device's current location and access locations saved on the device. This permission includes access to geolocation, geofencing, cell tower information, Wi-Fi data, and Cascades Places.", "Description of the access_location_services permission"),
		"iconFile": "location.png"
	},
	"access_operational_data_domain": {
		"name": qsTr("ADARP Operational Data Domain", "Name of the access_operational_data_domain permission"),
		"description": qsTr("As part of advanced data at rest protection (ADARP), this permission allows the app to access the operational data domain. The operational data domain is the part of the sandbox that is available after the user authenticates with the device initially. The operational data domain continues to be available when the work space is in a data lock state.", "Description of the access_operational_data_domain permission"),
		"iconFile": "data_lock.png"
	},
	"access_perimeter_mgr": {
		"name": "",
		"description": UNDOCUMENTED_PERMISSION_DESCR,
		"iconFile": "data_lock.png"
	},
	"access_phone": {
		"name": qsTr("Access Phone", "Name of the access_phone permission"),
		"description": qsTr("Allows the app to determine when a user is on a phone call. This access also allows an app to access the phone number assigned to the device and send DTMF (Dual Tone Multi-Frequency) tones.", "Description of the access_phone permission"),
		"iconFile": "phone.png"
	},
	"access_pim": {
		"name": "",
		"description": UNDOCUMENTED_PERMISSION_DESCR,
		"iconFile": "accounts.png"
	},
	"access_pimdata_social": {
		"name": "",
		"description": UNDOCUMENTED_PERMISSION_DESCR,
		"iconFile": "social_networks.png"
	},
	"access_pimdomain_calendars": {
		"name": qsTr("Access Calendar", "Name of the access_pimdomain_calendars permission"),
		"description": qsTr("Allows the app to access the calendar on the device. This permission includes viewing, adding, and deleting calendar appointments.", "Description of the access_pimdomain_calendars permission"),
		"iconFile": "calendar.png"
	},
	"access_pimdomain_calllogs": {
		"name": qsTr("Phone Call Logs", "Name of the access_pimdomain_calllogs permission"),
		"description": qsTr("Allows the app to view the logs of previous incoming or outgoing phone calls.", "Description of the access_pimdomain_calllogs permission"),
		"iconFile": "phone.png"
	},
	"access_pimdomain_contacts": {
		"name": qsTr("Access Contacts", "Name of the access_pimdomain_contacts permission"),
		"description": qsTr("Allows the app to access to the contacts stored on the device. This permission includes viewing, creating, and deleting contacts on the device and SIM card.", "Description of the access_pimdomain_contacts permission"),
		"iconFile": "contacts.png"
	},
	"access_pimdomain_messages": {
		"name": qsTr("Email and PIN Messages", "Name of the access_pimdomain_messages permission"),
		"description": qsTr("Allows the app to access the email and PIN messages stored on the device. This access includes viewing, creating, sending, and deleting messages.", "Description of the access_pimdomain_messages permission"),
		"iconFile": "email.png"
	},
	"access_pimdomain_notebooks": {
		"name": qsTr("Notebooks", "Name of the access_pimdomain_notebooks permission"),
		"description": qsTr("Allows the app to access the content stored in the notebooks on the device. This permission includes adding and deleting entries and content from notebooks.", "Description of the access_pimdomain_notebooks permissoin"),
		"iconFile": "notebooks.png"
	},
	"access_notifiy_settings_control": {
		"name": qsTr("Control Notification Settings", "Name of the access_notifiy_settings_control permission"),
		"description": qsTr("Allows the app to modify global notification settings. Apps only have permission to read their own notification settings.", "Description of the access_notifiy_settings_control permission"),
		"iconFile": "notification.png"
	},
	"access_shared": {
		"name": qsTr("Shared Files", "Name of the access_shared permission"),
		"description": qsTr("Allows the app to read and write the files that are shared between all apps on the device. This permission allows the app to access pictures, music, documents and other files that are stored on the user's device, at a remote storage provider, on a media card, or in the cloud.", "Description of the access_shared permission"),
		"iconFile": "share_files.png"
	},
	"access_sms_mms": {
		"name": qsTr("Text Messages", "Name of the access_sms_mms permission"),
		"description": qsTr("Allows the app to access the text messages stored on the device. This access includes viewing, creating, sending, and deleting text messages.", "Description of the access_sms_mms permission"),
		"iconFile": "sms.png"
	},
	"access_startup_data_domain": {
		"name": qsTr("ADARP Startup Data Domain", "Name of the access_startup_data_domain permission"),
		"description": qsTr("As part of the advanced data at rest protection (ADARP), this permission allows the app to access the startup data domain. The startup data domain is the part of the sandbox that is always available to the app, even if the user has not authenticated against the device yet or if the work space is in a data lock state.", "Description of the access_startup_data_domain permission"),
		"iconFile": "data_lock.png"
	},
	"access_wifi_public": {
		"name": qsTr("Wi-Fi Connection", "Name of the access_wifi_public permission"),
		"description": qsTr("Allows the app to receive Wi-Fi event notifications such as Wi-Fi scan results or changes in the Wi-Fi connection state. Also allows limited Wi-Fi control for hotspot aggregator applications that manage network selection and authentication to a hotspot./nThis permission doesn't allow the app to force a connection to a specific network profile when there are other available networks that have a higher priority configured on the device. This permission is NOT necessary for querying information about existing Wi-Fi connections.", "Description of the access_wifi_public permission"),
		"iconFile": "wifi.png"
	},
	"allow_request_lock": {
		"name": qsTr("ADARP Request Data Lock", "Name of the allow_request_lock permission"),
		"description": qsTr("As part of advanced data at rest protection (ADARP), this permission allows the app to request that the work space be put in a data lock state.", "Description of the allow_request_lock permission"),
		"iconFile": "data_lock.png"
	},
	"bbm_connect": {
		"name": qsTr("Connect to BBM", "Name of the bbm_connect permission"),
		"description": qsTr("Allows the app to connect to BlackBerry Messenger (BBM). This permission also allows the app to view contact lists and user profiles, invite BBM contacts to download the app, initiate BBM chats and share content from within the app, and stream data between apps in real time.", "Description of the bbm_connect permission"),
		"iconFile": "bbm.png"
	},
	"control_phone": {
		"name": qsTr("Phone Control", "Name of the control_phone permission"),
		"description": qsTr("Allows the app to combine two calls together, end a call, and use the dial pad during a call.", "Description of the control_phone permission"),
		"iconFile": "phone.png"
	},
	"hidden": {
		"name": "",
		"description": UNDOCUMENTED_PERMISSION_DESCR,
		"iconFile": "hidden.png"
	},
	"manage_pimdomain_accounts": {
		"name": "",
		"description": UNDOCUMENTED_PERMISSION_DESCR,
		"iconFile": "accounts.png"
	},
	"narrow_landscape_exit": {
		"name": qsTr("Narrow Swipe Up", "Name of the narrow_landscape_exit permission"),
		"description": qsTr("Allows the app, within a landscape orientation (typically games), to use the corner regions for menus and virtual game pads. This permission reduces the region of the home swipe up gesture to occur only in the middle edge of the bottom of the bezel instead of a full-length swipe. Use this permission to prevent the app from inadvertently going into the background when the corner regions are swiped.", "Description of the narrow_landscape_exit permission"),
		"iconFile": ""
	},
	"perimeter_corp": {
		"name": "",
		"description": UNDOCUMENTED_PERMISSION_DESCR,
		"iconFile": "data_lock.png"
	},
	"permanent": {
		"name": "",
		"description": UNDOCUMENTED_PERMISSION_DESCR,
		"iconFile": "permanent.png"
	},
	"play_audio": {
		"name": qsTr("Play Audio", "Name of the play_audio permission"),
		"description": qsTr("Allows the app to play an audio stream (in PlayBook OS). Seems to be deprecated for BlackBerry 10.", "Description of the play_audio permission"),
		"iconFile": "audio.png"
	},
	"post_notification": {
		"name": qsTr("Post Notifications", "Name of the post_notification permission"),
		"description": qsTr("Allows the app to post notifications. This permission is granted by the OS automatically when requested.", "Description of the post_notification permission"),
		"iconFile": "notification.png"
	},
	"read_device_identifying_information": {
		"name": qsTr("Device Identifying Information", "Name of the read_device_identifying_information permission"),
		"description": qsTr("Allows the app to access unique device identifiers such as the PIN and serial number. This permission also allows the app to access SIM card information on the device.", "Description of the read_device_identifying_information permission"),
		"iconFile": "device_id_info.png"
	},
	"read_geolocation": {
		"name": qsTr("GPS Location (Deprecated)", "Name of the read_geolocation permission"),
		"description": qsTr("This permission previously allowed access to the current GPS location of the device. Deprecated. The access_location_services permission should be used instead.", "Description of the read_geolocation permission"),
		"iconFile": "location.png"
	},
	"read_personally_identifiable_information": {
		"name": qsTr("User Contact Information", "Name of the read_personally_identifiable_information permission"),
		"description": qsTr("Allows the app to access user information on the device, such as the first name, last name, and BlackBerry ID username of the user currently associated with this device.", "Description of the read_personally_identifiable_information permission"),
		"iconFile": "contacts.png"
	},
	"read_phonecall_details": {
		"name": qsTr("Phone Call Details", "Name of the read_phonecall_details permission"),
		"description": qsTr("Allows the app to view the status of phone calls that are in progress and the phone number of the remote party.", "Description of the read_phonecall_details permission"),
		"iconFile": "phone.png"
	},
	"read_radio_modem_data": {
		"name": qsTr("Cellular Network Info", "Name of the read_radio_modem_data permission"),
		"description": qsTr("This is a non-documented permission, which allows the app to access cellular network information (such as Cell-ID, signal strength, roaming status, etc). These may be used to get coarse location information.", "Description of the read_radio_modem_data permission"),
		"iconFile": "mobile_network.png"
	},
	"record_audio": {
		"name": qsTr("Microphone", "Name of the record_audio permission"),
		"description": qsTr("Allows the app to access the audio stream from the microphone on the device.", "Description of the record_audio permission"),
		"iconFile": "microphone.png"
	},
	"run_air_native": {
		"name": qsTr("Run Native AIR Code", "Name of the run_air_native permission"),
		"description": qsTr("Run the app using Adobe AIR runtime. This permission is used by BlackBerry 10 apps built with Adobe AIR.", "Description of the run_air_native permission"),
		"iconFile": "run_native.png"
	},
	"run_native": {
		"name": qsTr("Run Native Code", "Name of the run_native permission"),
		"description": qsTr("Run the app using OS runtime. This permission is used by all native BlackBerry 10 apps.", "Description of the run_native permission"),
		"iconFile": "run_native.png"
	},
	"run_when_backgrounded": {
		"name": qsTr("Run as Active Frame", "Name of the run_when_backgrounded permission"),
		"description": qsTr("Allows the app to perform background processing. Without this permission, the app will be stopped when the user switches focus to another app. This permission is useful for apps that play music or manage downloads.", "Description of the run_when_backgrounded permission"),
		"iconFile": "run_in_background.png"
	},
	"run_when_data_locked": {
		"name": qsTr("ADARP Run when Data Locked", "Name of the run_when_data_locked permission"),
		"description": qsTr("As part of advanced data at rest protection (ADARP), this permission allows the app to run when the work space is in a data lock state.", "Description of the run_when_data_locked permission"),
		"iconFile": "data_lock.png"
	},
	"use_gamepad": {
		"name": qsTr("Gamepad", "Name of the use_gamepad permission"),
		"description": qsTr("Indicates that the app supports gamepad functionality. This permission also indicates that the app has official gamepad support in the BlackBerry World storefront.", "Description of the use_gamepad permission"),
		"iconFile": "gamepad.png"
	},
	"use_camera": {
		"name": qsTr("Camera", "Name of the use_camera permission"),
		"description": qsTr("Allows the app to access any of the data coming from cameras on the device. This permission allows an app to take pictures, record video, and use the flash on the device.", "Description of the use_camera permission"),
		"iconFile": "camera.png"
	},
	"use_camera_desktop": {
		"name": qsTr("Screen Capture", "Name of the use_camera_desktop permission"),
		"description": qsTr("Allows the app to take screen shots or videos of the user's screen. This permission also allows the app to share the user's screen.", "Description of the use_camera_desktop permission"),
		"iconFile": "camera.png"
	},
};

/**
 * Given permission ID (e.g. "access_internet") returns its title ("Access Internet"),
 * detailed description and icon path.
 * For unknown permissions returns generic icon and an appropriate description.
 */
function getPermissionInfo(id) {
	var result;
	if (id in PERMISSION_INFO) {
		result = PERMISSION_INFO[id];
		if (result.iconFile == "")
			result.iconFile = "_unknown.png";
	} else {
		result = {
			"name": "",
			"description": UNDOCUMENTED_PERMISSION_DESCR,
			"iconFile": "_unknown.png"
		}
	}
	result["id"] = id;
	return result;
}
