import bb.cascades 1.4

Sheet {
    Page {
        titleBar: TitleBar {
            title: qsTr("About Permissions", "Title of page which describes limitations of the permissions info in AppNinja") + Retranslate.onLocaleOrLanguageChanged
            dismissAction: ActionItem {
                title: qsTr("Close") + Retranslate.onLocaleOrLanguageChanged
                onTriggered: {
                    close();
                }
            }
        }
        ScrollView {
            scrollRole: ScrollRole.Main
            verticalAlignment: VerticalAlignment.Fill
            horizontalAlignment: HorizontalAlignment.Fill
            Container {
                leftPadding: ui.du(2)
                rightPadding: ui.du(2)
                Label{
                    text: qsTr(
                        "The Permissions list is an experimental feature. Quite often the list is incomplete.\n\n" +
                        "The reason is that for some apps the system provides only partial information about permissions. " +
                        "Even if an app requests a permission, the latter might not appear in the list.\n\n" +
                        "For example, some Internet-connected apps (such as Wikipedia app) " +
                        "seemingly do not request the <i>access_internet</i> permission.\n\n" + 
                        "However, if some permission <b>is</b> listed &mdash; the app certainly does request that permission. ",
                        "Content of the 'About Permissions' page.") +
                        Retranslate.onLocaleOrLanguageChanged
                    textFormat: TextFormat.Html
                    multiline: true
                }
            }
        }
    }
}